<template>
  <div id="vueapp" class='container'>
    <div class='row'>
      <flash-msg></flash-msg>
      <top-panel></top-panel>
      <left-panel></left-panel>
      <main-panel></main-panel>
    </div>
  </div>
</template>

<script>
  export default {
    mounted() {
      if (this.$store.state.user.email) {
        this.checkUser()
      }
      this.$root.$on('signInUser', (userParams) => {
        this.signInUser(userParams)
      })
    },
    methods: {
      checkUser() {
        const url = '/api/v1/sessions/check_user'
        this.$http.get(url, { headers: { 'auth-token': this.$store.state.user.auth_token }}).then((response) => {
          let message = response.body.message
          let logged = response.body.logged
          if (!logged) {
            this.$root.$emit('setFlashMsg', { message: response.body.message, type: 'error' })
            this.$store.dispatch('signOut')
            this.$root.$emit('signOut')
          }
        }).catch((error) => {
          this.$root.$emit('setFlashMsg', { message: error.body.message, type: 'error' })
          this.$store.dispatch('signOut')
          this.$root.$emit('signOut')
        })
      },
      signInUser (userParams) {
        const url = '/api/v1/sessions'
        this.$http.post(url, { email: userParams['email'], password: userParams['password'] }).then((response) => {
          this.$store.dispatch('signIn', response.body.user)
          this.$router.push('/')
          this.$root.$emit('setFlashMsg', {message: response.body.message, type: 'normal' })
          this.$root.$emit('signIn')
        }).catch((error) => {
          this.$root.$emit('setFlashMsg', {message: error.body.message, type: 'error' })
        })
      },
    }
  }
</script>
